
<canvas id="canvas" width="1000" height="1000"></canvas>

<script type="text/javascript">
  var canvas = document.getElementById("canvas")
  var ctx = canvas.getContext("2d")

  function setPixel(x, y, r, g, b) {
    // draw a 1x1 rect
    ctx.fillStyle = "rgba("+r+","+g+","+b+")";
    ctx.fillRect(x, y, 1, 1)
  }

  var wsUrl = window.location.origin.replace(/^http/, 'ws') + "/display"
  console.log("Connecting to " + wsUrl)
  var socket = new WebSocket(wsUrl);
  socket.onmessage = function(event) {
    var split = event.data.split(" ")

    /*
    if (split[0] != "PX" || split.length != 4) {
      console.log("Bad message: " + event.data)
      return
    }
    */

    var x = Number(split[1])
    var y = Number(split[2])
    var r = parseInt(split[3][0] + split[3][1], 16)
    var g = parseInt(split[3][2] + split[3][3], 16)
    var b = parseInt(split[3][4] + split[3][5], 16)

    setPixel(x, y, r, g, b)
  }

  /* testing code
  // setPixel test
  for (var x = 100; x < 150; x++) {
    for (var y = 100; y < 150; y++) {
      setPixel(x, y, 0, 255, 0)
    }
  }

  var testUrl = window.location.origin.replace(/^http/, 'ws')
  console.log(testUrl)
  var testSocket = new WebSocket(testUrl);
  testSocket.onopen = function (event) {
    console.log("Test Connected.")
    for (var x = 200; x < 250; x++) {
      for (var y = 200; y < 250; y++) {
        testSocket.send("PX " + x + " " + y + " 00ff00")
      }
    }
  }
  // */
</script>
